﻿Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            GridView1.DataSource = GetData("SELECT ContactName, Country FROM Customers")
            GridView1.DataBind()
        End If
    End Sub

    Private Function GetData(query As String) As DataSet
        Dim conString As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Dim cmd As New SqlCommand(query)
        Using con As New SqlConnection(conString)
            Using sda As New SqlDataAdapter()
                cmd.Connection = con

                sda.SelectCommand = cmd
                Using ds As New DataSet()
                    sda.Fill(ds)
                    Return ds
                End Using
            End Using
        End Using
    End Function

    Protected Sub OnRowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            'Find the DropDownList in the Row
            Dim ddlCountries As DropDownList = CType(e.Row.FindControl("ddlCountries"), DropDownList)
            ddlCountries.DataSource = GetData("SELECT DISTINCT Country FROM Customers")
            ddlCountries.DataTextField = "Country"
            ddlCountries.DataValueField = "Country"
            ddlCountries.DataBind()
            'Add Default Item in the DropDownList
            ddlCountries.Items.Insert(0, New ListItem("Please select"))
            ' Select the Country of Customer in DropDownList
            Dim country As String = CType(e.Row.FindControl("lblCountry"), Label).Text
            ddlCountries.Items.FindByValue(country).Selected = True
        End If
    End Sub
End Class